import java.sql.*;


// Wrapper per la classe Employee

public final class EmployeeWrap extends Wrapper 
{

 public EmployeeWrap()
 {
 	_type = "O_EMPLOYEE"; 
 }
 
 public EmployeeWrap(Employee obj)
 {
 	this();
    this._obj = obj;
 }
 
 public void readSQL(SQLInput stream, String typeName) 
 {
  try
  {

System.out.println("## Employee WRAP ENTER READ SQL");
System.out.println("## TYPE NAME : " + typeName);
  long empno = stream.readLong();
  String ename = stream.readString(); 
  String job = stream.readString();
  int mgr = stream.readInt();
  java.sql.Date hiredate = stream.readDate();
  double sal = stream.readDouble();
  double comm = stream.readDouble();
  long deptno = stream.readLong();
	
  _obj = new Employee(empno, ename, job, mgr, hiredate, sal, comm, deptno);
System.out.println("## Employee WRAP EXIT READ SQL\n");    
  }
  catch(Exception e)
  {
    e.printStackTrace();
  }
  
 }
 
 public void writeSQL(SQLOutput stream) 
 {
  System.out.println("## Employee WRAP ENTER WRITE SQL");
  try
  {
    if(_obj == null)
      System.out.println("Employee WRAP OBJ == NULL");
     
    Employee obj = (Employee)_obj;
    
	stream.writeLong(obj.empno);
  	stream.writeString(obj.ename); 
  	stream.writeString(obj.job);
  	stream.writeInt(obj.mgr);
  	stream.writeDate(obj.hiredate);
  	stream.writeDouble(obj.sal);
  	stream.writeDouble(obj.comm);
  	stream.writeLong(obj.deptno);
  }
  catch(Exception e)
  {
    e.printStackTrace();
  }

System.out.println("## Employee WRAP EXIT WRITE SQL\n");
 }
}