
import java.sql.*;
import java.util.*;
import java.io.*;

/*
 * GET EMPLOYEE: legge un oggetto di tipo Employee 
 */
public final class GetEmployee
{
  String url = "jdbc:oracle:thin:@brucaliffo:1521:ORADB";
  String user = "scott";
  String pass = "tiger";
  
  /*
   *  Singleton 
   */
  public static GetEmployee getInstance()
  {
    return new GetEmployee();
  }
  
  
 /*
  *  Restituisce la Type Map 
  */
  final Hashtable getMap()
  {
    Hashtable map = new Hashtable();
    
	map.put("O_EMPLOYEE", EmployeeWrap.class);
    return map;
  }
  
  
  /*
   *  Main 
   */
    public static final void main(String[] args)
  {
        
	try
	{
		  
    	Wrapper wrapper = GetEmployee.getInstance().execute("{? = call P_TEST.get_employee(?)}", "O_EMPLOYEE");	
		System.out.println(Snoopy.snoop(wrapper.getWrappedObj()));
	}
    

		catch (SQLException sqle)
		{
		  sqle.printStackTrace();
		}
		catch(Exception e)
		{
		  e.printStackTrace();
		}
   
  }
  
  /*
   *  Chiama la Stored Procedure e restituisce un Wrapper 
   */
  public final Wrapper execute(String procedure, String type) throws Exception
  {
      
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
    
	//connessione
    Connection conn = DriverManager.getConnection(url, user, pass);
    
	//statement
    CallableStatement statement = conn.prepareCall
    (
      conn.nativeSQL(procedure)
    );
    
    System.out.println("PROCEDURE : " + procedure);
    System.out.println("TYPE : " + type);
	
	// key =7788
		statement.setLong(2, 7788L);
	// return = O_EMPLOYEE		
		statement.registerOutParameter(1, oracle.jdbc.driver.OracleTypes.STRUCT, type);
			 
    statement.execute();
    
    Hashtable map = GetEmployee.getInstance().getMap();
   
    // legge l'oggetto dallo statement secondo la mappa data da noi 
    Wrapper wrap = (Wrapper)statement.getObject(1, map);
    
    statement.close();
    conn.close();
    
    return wrap;    
  }
  
 
}