CREATE OR REPLACE PACKAGE P_Global IS

TYPE RefCursor IS REF CURSOR;

END P_Global;
/

CREATE OR REPLACE PACKAGE P_Test IS

FUNCTION GET_EMPLOYEE RETURN P_Global.RefCursor;
FUNCTION GET_EMPLOYEE (KEY NUMBER) RETURN O_EMPLOYEE;

FUNCTION SET_EMPLOYEE (EMPLOYEE O_EMPLOYEE) RETURN NUMBER;
FUNCTION SET_EMPLOYEE (EMPLOYEES A_EMPLOYEE) RETURN A_NUMBER;

END P_Test;
/

CREATE OR REPLACE PACKAGE BODY P_Test IS

FUNCTION GET_EMPLOYEE RETURN P_Global.RefCursor IS

  crs P_Global.RefCursor;

BEGIN

	 OPEN crs FOR
	 SELECT O_EMPLOYEE( EMPNO, ENAME, JOB,  MGR, HIREDATE, SAL , COMM , DEPTNO)
	 FROM EMP;

RETURN crs;

END GET_EMPLOYEE;

FUNCTION GET_EMPLOYEE (KEY NUMBER) RETURN O_EMPLOYEE IS

 o_emp O_EMPLOYEE;

BEGIN
	 SELECT O_EMPLOYEE( EMPNO, ENAME, JOB,  MGR, HIREDATE, SAL , COMM , DEPTNO)
	 INTO o_emp
	 FROM EMP
	 WHERE empno = KEY;

	 RETURN o_emp;

END GET_EMPLOYEE;

FUNCTION SET_EMPLOYEE (EMPLOYEE O_EMPLOYEE) RETURN NUMBER IS

 PKEY NUMBER;

BEGIN
	 SELECT MAX(empno) INTO PKEY FROM EMP;

	 IF PKEY IS NULL THEN
	 	 PKEY := 0;
	 END IF;
	 PKEY := PKEY + 1;

	 INSERT INTO EMP ( EMPNO, ENAME, JOB, MGR, HIREDATE, SAL, COMM, DEPTNO )
	 VALUES ( PKEY, EMPLOYEE.ENAME, EMPLOYEE.JOB, EMPLOYEE.MGR,
	 EMPLOYEE.HIREDATE, EMPLOYEE.SAL, EMPLOYEE.COMM, EMPLOYEE.DEPTNO );

	 RETURN PKEY;

END SET_EMPLOYEE;

FUNCTION SET_EMPLOYEE (EMPLOYEES A_EMPLOYEE) RETURN A_NUMBER IS

 PKEYS A_NUMBER := A_NUMBER();
 
BEGIN
	 FOR i IN 1..EMPLOYEES.COUNT LOOP
		 PKEYS.extend();
		 PKEYS(PKEYS.COUNT):= SET_EMPLOYEE(EMPLOYEES(i));  
	 END LOOP;

	 RETURN PKEYS;
END SET_EMPLOYEE;

END P_Test;
/

